procedure setTmp(var map : t256; x, y : integer; c : byte);
begin
	if map[x,y]=0 then map[x,y]:=c;
end;

procedure subDiv(var map : t256; x1, y1, x2, y2 : integer); forward;

procedure subDiv(var map : t256; x1, y1, x2, y2 : integer);
var
	x, y			: integer;
    m1, m2, m3, m4 	: integer;
begin
	x:=(x1+x2) div 2;
	y:=(y1+y2) div 2;

    if (x=x1) and (y=y1) then exit;

    m1:=map[x1,y1];
    m2:=map[x2,y1];
    m3:=map[x1,y2];
    m4:=map[x2,y2];

    if (map[x,y]=0) then setTmp(map,x,y,crop((m1+m2+m3+m4) div 4+(random((x2-x1)*st*2)-(x2-x1)*st*1)+(random((y2-y1)*st*2)-(y2-y1)*st*1)));

    if (map[x,y1]=0) then setTmp(map,x,y1,crop((m1+m2) div 2+(random((x2-x1)*st*2)-(x2-x1)*st*1)));
    if (map[x,y2]=0) then setTmp(map,x,y2,crop((m3+m4) div 2+(random((x2-x1)*st*2)-(x2-x1)*st*1)));

    if (map[x1,y]=0) then setTmp(map,x1,y,crop((m1+m3) div 2+(random((y2-y1)*st*2)-(y2-y1)*st*1)));
    if (map[x2,y]=0) then setTmp(map,x2,y,crop((m2+m4) div 2+(random((y2-y1)*st*2)-(y2-y1)*st*1)));

    subDiv(map, x1,y1,x,y);
    subDiv(map, x1,y,x,y2);
    subDiv(map, x,y,x2,y2);
    subDiv(map, x,y1,x2,y);
end;

procedure smooth(var map : t256);
var
	c		: integer;
    x, y	: integer;
    map2	: ^t256;
begin
	new(map2);
    for x:=0 to mapW do begin
		for y:=0 to mapH*2 do begin
	    	c:=map[x,y]-128;
	    	if x>0 then c:=c+map[x-1,y]-128 else
		    	c:=c+map[x,y]-128;
	    	if x<mapW-1 then c:=c+map[x+1,y]-128 else
		    	c:=c+map[x,y]-128;
	    	if y>0 then c:=c+map[x,y-1]-128 else
		    	c:=c+map[x,y]-128;
	    	if y<mapH*2-1 then c:=c+map[x,y+1]-128 else
		    	c:=c+map[x,y]-128;
            map2^[x,y]:=c div 5+128;
	    end;
    end;
    for x:=0 to mapW do begin
		for y:=0 to mapH*2 do begin
	       	map[x,y]:=map2^[x,y];
	    end;
    end;
    dispose(map2)
end;

procedure setMap(var map : tMap; x, y : integer; i, c : byte; pas, see : boolean);
begin
	if (x>=0) and (x<=mapW) and (y>=0) and (y<=mapH) then begin
		map.level[x,y].img:=i;
		map.level[x,y].col:=c;
		map.level[x,y].pas:=pas;
		map.level[x,y].see:=see;
	end;
end;

procedure addForrest(var map : tMap);
var
	x, y, i		:  integer;
begin
	repeat
		x:=random(mapW);
		y:=random(mapH);
	until map.level[x,y].pas=true;
	for i:=0 to random(100)+50 do begin
		if x<0 then x:=x+mapW+1;
		if y<0 then y:=y+mapH+1;
		if x>mapW then x:=x-mapW-1;
		if y>mapH then y:=y-mapH-1;
		if map.level[x,y].pas=true then begin
			setMap(map, x, y, ord('!'), 2, T, T);
		end;
		x:=x+random(3)-1;
		y:=y+random(3)-1;
	end;
end;

procedure addTown(var map : tMap);
var
	x, y, i		:  integer;
begin
	repeat
		x:=random(mapW div 2)*2;
		y:=random(mapH div 2)*2;
	until (map.level[x,y].pas=true) and (map.level[x,y].canGoTo);
	i:=random(3);
	if i=0 then SetMap(map, x, y, ord('o'), 7, F, T);
	if i=1 then SetMap(map, x, y, ord('o'), 2, F, T);
	if i=2 then SetMap(map, x, y, ord('o'), 6, F, T);
end;

procedure addDungeon(var map : tMap);
var
	x, y		:  integer;
	cont		:  boolean;
begin
	repeat
		cont:=false;
		x:=random(mapW-2)+1;
		y:=random(mapH-2)+1;
		if (map.level[x-1,y].canGoTo) then cont:=true;
		if (map.level[x+1,y].canGoTo) then cont:=true;
		if (map.level[x,y-1].canGoTo) then cont:=true;
		if (map.level[x,y+1].canGoTo) then cont:=true;
		if (map.level[x-1,y].img=ord('*')) then cont:=false;
		if (map.level[x+1,y].img=ord('*')) then cont:=false;
		if (map.level[x,y-1].img=ord('*')) then cont:=false;
		if (map.level[x,y+1].img=ord('*')) then cont:=false;
	until (cont) and (map.level[x,y].img=ord('^'));
	setMap(map, x, y, ord('*'), 7, F, T);
end;

procedure floodFill(var map : tMap; x,y : integer);
begin
	while (map.level[x-1,y].pas=true) do x:=x-1;
	repeat
		map.level[x,y].canGoTo:=true;
		if (map.level[x,y-1].canGoTo=false) and (map.level[x,y-1].pas=true) then begin
			floodFill(map,x,y-1);
		end;
		if (map.level[x,y+1].canGoTo=false) and (map.level[x,y+1].pas=true) then begin
			floodFill(map,x,y+1);
		end;
		x:=x+1;	
	until (map.level[x,y].pas=false);
end;

procedure clearMap(var map : tMap);
var
	i		:  integer;
begin
	for	i:=0 to 10000 do begin
		if map.item[i]<>nil then begin
			dispose(map.item[i]);
			map.item[i]:=nil;
		end;
	end;
end;

procedure makeTopMap(var map : tMap; id : longInt);
var
	x, y		: integer;
	tmp			: ^t256;
	d			: integer;
begin
	clearMap(map);
	new(tmp);
	repeat
		for x:=0 to mapW do for y:=0 to mapH*2 do begin
		    tmp^[x,y]:=0;
	    end;
		for x:=0 to mapW do for y:=0 to mapH do begin
			map.level[x,y].isSeen:=F;
			map.level[x,y].toLevel:=-999;
		end;
		for x:=0 to mapW do begin
			tmp^[x,0]:=1;
			tmp^[x,mapH*2]:=1;
		end;
		for x:=0 to mapH*2 do begin
			tmp^[0,x]:=1;
			tmp^[mapW,x]:=1;
		end;
	
		tmp^[mapW div 2,mapH]:=255;
	    
	    subDiv(tmp^, 0,0,mapW,mapH*2);
	
	 	for y:=0 to 5 do begin
			smooth(tmp^);
			for x:=0 to mapW do begin
				tmp^[x,0]:=1;
				tmp^[x,mapH*2]:=1;
			end;
			for x:=0 to mapH*2 do begin
				tmp^[0,x]:=1;
				tmp^[mapW,x]:=1;
			end;
		end;  
	
	 	for x:=0 to mapW do for y:=0 to mapH do begin
			if tmp^[x,y*2] <64  then setMap(map,x,y,ord('='), 1,F,T);
			if tmp^[x,y*2]>=64  then begin
				if random(2)=0 then 
					setMap(map,x,y,ord('`'), 2,T,T)
				else
					setMap(map,x,y,ord(''''), 2,T,T);
			end;
			if tmp^[x,y*2]>=100 then setMap(map,x,y,ord('.'), 2,T,T);
			if tmp^[x,y*2]>=192 then setMap(map,x,y,ord('^'), 7,F,F);
			map.level[x,y].canGoTo:=false;
		end; 

		repeat
			x:=random(mapW);
			y:=random(mapH);
		until (map.level[x,y].pas=true);
		
		floodFill(map,x,y);

		d:=0;	
		for x:=0 to mapW do for y:=0 to mapH do begin
			if map.level[x,y].canGoTo then d:=d+1;
		end;
	until d>1000;
    
    for x:=0 to random(10)+5 do begin
		addForrest(map);
	end;
    for x:=0 to random(10)+10 do begin
		addTown(map);
	end;
    for x:=0 to random(20)+25 do begin
		addDungeon(map);
	end;  
	dispose(tmp);

	map.id:=id;
end;

procedure makeMap(var map : tMap; id : longInt);
var
	x, y, i		: integer;
	tmp			: ^t256;
	n, d		: integer;
	width		: integer;
	typ			: integer;
begin
	typ:=random(10);
	new(tmp);
	clearMap(map);
	repeat
		width:=random(45)+70;
		repeat
			for x:=0 to mapW do for y:=0 to mapH*2 do begin
			    tmp^[x,y]:=0;
			end;
			for x:=0 to mapW do for y:=0 to mapH do begin
				map.level[x,y].isSeen:=F;
			    map.level[x,y].toLevel:=-999;
			end;
			for x:=0 to mapW do begin
				tmp^[x,0]:=255;
				tmp^[x,mapH*2]:=255;
			end;
			for x:=0 to mapH*2 do begin
				tmp^[0,x]:=255;
				tmp^[mapW,x]:=255;
			end;
		
			tmp^[mapW div 2,mapH]:=1;
		    
			subDiv(tmp^, 0,0,mapW,mapH*2);
		
   			for x:=0 to mapW do for y:=0 to mapH*2 do begin
	   			if tmp^[x,y]>128 then tmp^[x,y]:=256-tmp^[x,y];
	   		end;
		
			for y:=0 to 2 do begin
				smooth(tmp^);
				for x:=0 to mapW do begin
					tmp^[x,0]:=1;
					tmp^[x,mapH*2]:=1;
				end;
				for x:=0 to mapH*2 do begin
					tmp^[0,x]:=1;
					tmp^[mapW,x]:=1;
				end;
			end; 
		
  			for x:=0 to mapW do for y:=0 to mapH do begin
				if tmp^[x,y*2] <width then setMap(map,x,y,ord('#'), 8,F,F);
				if tmp^[x,y*2]>=width then setMap(map,x,y,ord('.'), 7,T,T);
				map.level[x,y].canGoTo:=false;
			end;
		
			d:=0;
			repeat
				x:=random(mapW);
				y:=random(mapH);
				d:=d+1;
			until (map.level[x,y].pas=true) or (d>1000);
		until d<=1000;
		
		floodFill(map, x,y);

		d:=0;	
		for x:=0 to mapW do for y:=0 to mapH do begin
			if map.level[x,y].canGoTo then d:=d+1;
		end;
	until (d>100) and (d<25000);
	
	if d<300 then addMsg('This level feels small.');
	if (d>3000) and (d<10000) then addMsg('This feels like a big level.');
	if d>=10000 then addMsg('Wow. This level feels huge!');

  	for x:=0 to mapW do for y:=0 to mapH do begin
  		if typ=0 then begin
			if map.level[x,y].canGoTo=false then 
				setMap(map,x,y,ord('#'), 8,F,F)
			else
				setMap(map,x,y,ord('.'), 8,T,T);
	  	end else begin
			if map.level[x,y].canGoTo=false then 
				setMap(map,x,y,ord('#'), 8,F,F)
			else
				setMap(map,x,y,ord('.'), 8,T,T);
  		end;
    end;
    
	dispose(tmp);

	repeat
		x:=random(mapW-2)+1;
		y:=random(mapH-2)+1;
		n:=0;
		if map.level[x-1,y].pas=true then n:=n+1; 
		if map.level[x+1,y].pas=true then n:=n+1; 
		if map.level[x,y-1].pas=true then n:=n+1; 
		if map.level[x,y+1].pas=true then n:=n+1; 
	until (map.level[x,y].img=ord('#')) and (n=1);
	setMap(map,x,y,ord('>'), 15,F,T);
	
	repeat
		x:=random(mapW-2)+1;
		y:=random(mapH-2)+1;
		n:=0;
		if map.level[x-1,y].pas=true then n:=n+1; 
		if map.level[x+1,y].pas=true then n:=n+1; 
		if map.level[x,y-1].pas=true then n:=n+1; 
		if map.level[x,y+1].pas=true then n:=n+1; 
	until (map.level[x,y].img=ord('#')) and (n=1);
	
	setMap(map,x,y,ord('<'), 15,F,T);
	
	for i:=0 to 300 do begin
		x:=random(mapW);
		y:=random(mapH);
		if map.level[x,y].img=ord('.') then begin
			new(map.item[i]);
			map.item[i]^:=getRandomItem;
			map.item[i]^.x:=x;
			map.item[i]^.y:=y;
		end;
	end;

	map.id:=id;
end;

procedure makeRoomMap(var map : tMap; id : longInt);
var
	x, y, i		: longint;
	n			: integer;
	typ			: integer;
	x1, y1, x2, y2	:  integer;
	
	function checkRoom(x1, y1, x2, y2 : integer) : boolean;
	var
		x, y		:  integer;
		r			:  boolean;
	begin
		r:=false;
		for x:=x1-1 to x2+1 do for y:=y1-1 to y2+1 do begin
			if map.level[x,y].canGoTo=true then r:=true;
		end;
		if r=false then begin
			for x:=x1 to x2 do for y:=y1-2 to y2+2 do begin
				if map.level[x,y].canGoTo=true then r:=true;
			end;
			for x:=x1-2 to x2+2 do for y:=y1 to y2 do begin
				if map.level[x,y].canGoTo=true then r:=true;
			end;
		end else begin
			r:=false;
		end;
		checkRoom:=r;
	end;
	
	procedure addRoom(x1, y1, x2, y2 : integer);
	var
		x, y		:  integer;
	begin
		for x:=x1 to x2 do for y:=y1 to y2 do begin
			map.level[x,y].canGoTo:=true;
		end;
	end;

	procedure addDoor(x1, y1, x2, y2 : integer);
	var
		x, y		:  integer;
		i			:  integer;
	begin
		gotoxy(1,1);
		repeat
			if random(2)=0 then begin
				x:=random(x2-x1+1)+x1;
				if random(2)=0 then 
					y:=y1-1
				else
					y:=y2+1;
			end else begin
				y:=random(y2-y1+1)+y1;
				if random(2)=0 then 
					x:=x1-1
				else
					x:=x2+1;
			end;
			i:=0;
			if map.level[x-1,y].canGoTo=true then i:=i+1;
			if map.level[x+1,y].canGoTo=true then i:=i+1;
			if map.level[x,y-1].canGoTo=true then i:=i+1;
			if map.level[x,y+1].canGoTo=true then i:=i+1;
		until (i>1);
		map.level[x,y].canGoTo:=true;
	end;
	
begin
	typ:=random(10);
	clearMap(map);
	for x:=0 to mapW do for y:=0 to mapH do begin
		map.level[x,y].isSeen:=F;
	    map.level[x,y].toLevel:=-999;
	    map.level[x,y].canGoTo:=false
	end;
	
	x1:=random(mapW-30)+5;
	y1:=random(mapH-20)+5;
	x2:=x1+random(12)+4;
	y2:=y1+random(6)+2;
	addRoom(x1,y1,x2,y2);

	for i:=0 to 10000 do begin
		x1:=random(mapW-30)+5;
		y1:=random(mapH-20)+5;
		n:=random(3);
		if n=0 then begin
			x2:=x1+random(12)+4;
			y2:=y1+random(6)+2;
		end;
		if n=1 then begin
			x2:=x1+random(12)+6;
			y2:=y1;
		end;
		if n=2 then begin
			x2:=x1;
			y2:=y1+random(6)+3;
		end;
		if checkRoom(x1, y1, x2, y2) then begin 
			addRoom(x1,y1,x2,y2);
			addDoor(x1,y1,x2,y2)
		end;
	end;

  	for x:=0 to mapW do for y:=0 to mapH do begin
		if map.level[x,y].canGoTo=false then 
			setMap(map,x,y,ord('#'), 7,F,F)
		else
			setMap(map,x,y,ord('.'), 8,T,T);
    end;
    
	repeat
		x:=random(mapW-2)+1;
		y:=random(mapH-2)+1;
		n:=0;
		if map.level[x-1,y].pas=true then n:=n+1; 
		if map.level[x+1,y].pas=true then n:=n+1; 
		if map.level[x,y-1].pas=true then n:=n+1; 
		if map.level[x,y+1].pas=true then n:=n+1; 
	until (map.level[x,y].img=ord('#')) and (n=1);
	setMap(map,x,y,ord('>'), 15,F,T);
	
	repeat
		x:=random(mapW-2)+1;
		y:=random(mapH-2)+1;
		n:=0;
		if map.level[x-1,y].pas=true then n:=n+1; 
		if map.level[x+1,y].pas=true then n:=n+1; 
		if map.level[x,y-1].pas=true then n:=n+1; 
		if map.level[x,y+1].pas=true then n:=n+1; 
	until (map.level[x,y].img=ord('#')) and (n=1);
	
	setMap(map,x,y,ord('<'), 15,F,T);
	
	for i:=0 to 300 do begin
		x:=random(mapW);
		y:=random(mapH);
		if map.level[x,y].img=ord('.') then begin
			new(map.item[i]);
			map.item[i]^:=getRandomItem;
			map.item[i]^.x:=x;
			map.item[i]^.y:=y;
		end;
	end;

	map.id:=id;
end;
