uses
        crt;
	
const
	st		=  7;
	t		=  true;
	f		=  false;
	
	mapW	=  128;
	mapH	=  64;
	maxMsg	=  100;
	
	linL	=  192;
	linT	=  195;
	linH	=  196;
	linV	=  179;

type
	tPos		=
		record
			x, y		:  integer;
		end;

	pItem	= ^tItem;
	tItem	=
		record
			typ			:  integer;
			x, y		:  integer;
			numItems	:  integer;
			weight		:  integer;
			a			:  string[10];
			name		:  string[80];
			img, col	:  byte;
		end;

	tCharacter	=
		record
			name			:  string[80];
			hp, hpMax		:  integer;
			pos				:  tPos;
			img, col		:  byte;
		end;

	tMapRuta	=
		record
			img, col		:  byte;
			pas, see		:  boolean;
			isSeen			:  boolean;
			toLevel			:  longInt;
			canGoTo			:  boolean;
		end;
		
	tMap		=  
		record
			id				:   longInt;
			item			:	array[0..10000] of pItem;
			level			:	array[0..mapW,0..mapH] of tMapRuta;
		end;
	pMap		= ^tMap;
	t256		=  array[0..mapW,0..mapH*2] of byte;
	tItemList	=  array[0..1000] of pItem;
	
var
	mapSave					:  array[0..100000] of pMap;
	numLevels				:  integer;
	inv						:  tItemList;
	tmpScr					:  array[0..80*50] of byte;
	msg						:  array[0..maxMsg] of string[80];
	line					:  string[80];
	infoMode				:  boolean;
	equip					:  array[0..20] of pItem;

function toStr(v : integer) : string;
var
	st			: string;
begin
	str(v, st);
	toStr:=st;
end;

procedure putChar(x, y, char, col : byte);
begin
	if (x>=0) and (y>=0) and (x<80) and (y<25) then begin
		if col=255 then col:=1+random(2)*8;
		if col=254 then col:=3+random(2)*8;
		tmpScr[(x+y*80)*2  ]:=char;
		tmpScr[(x+y*80)*2+1]:=col;
	end;
end;

function getCol(c : char) : byte;
begin
	case c of
		'0' : getCol:=0;
		'1' : getCol:=1;
		'2' : getCol:=2;
		'3' : getCol:=3;
		'4' : getCol:=4;
		'5' : getCol:=5;
		'6' : getCol:=6;
		'7' : getCol:=7;
		'8' : getCol:=8;
		'9' : getCol:=9;
		'a' : getCol:=10;
		'b' : getCol:=11;
		'c' : getCol:=12;
		'd' : getCol:=13;
		'e' : getCol:=14;
		'f' : getCol:=15;
	end;
end;

procedure skriv(xx, y : byte; st : string; col : byte);
var
	x, i		:  integer;
	s			:  char;
begin
	if length(st)>0 then begin
		x:=xx;
		i:=1;
		repeat
			s:=st[i];
			if s='' then begin
				col:=getCol(st[i+1]);
				i:=i+1
			end else begin
				putChar(xx,y,ord(s),col);
				xx:=xx+1;
			end;
			i:=i+1
		until i>length(st);
	end;
end;

procedure skrivC(x, y : byte; st : string; col : byte);
begin
	skriv(x-(length(st)+1) div 2,y,st,col);
end;

procedure init;
begin
	clrScr;
	gotoXY(1,25);
end;

procedure clear;
begin
	textBackground(0);
	textColor(7);
	clrScr;
end;

procedure addMsg(st : string[80]);
var
	i		:  integer;
begin
	for	i:=0 to maxMsg-1 do begin
		msg[i]:=msg[i+1];
	end;
	msg[maxMsg]:=st;
end;

{$i inc\makeitems.pp}

procedure saveMap(var map : pMap);
begin
	mapSave[map^.id]:=map;
end;

procedure loadMap(var map : pMap; mapNum : longint);
begin
	map:=mapSave[mapNum];
end;

function crop(i : integer) : byte;
begin
	if i<1 then i:=1;
	if i>255 then i:=255;
	crop:=i;
end;

{$i inc\makemaps.pp}

procedure drawMap(var map : tMap; xP, yP : longint);
var
	x, y, i		:  longint;
	xx, yy		:  longint;
	isSeen		:  array[0..80, 0..22] of boolean;
	itemsHere	:  integer;
	itemStr		:  string;
	xSize		:  integer;
	
	procedure castRay(dir : real);
	var
		x, y		:  real;
		co, si		:  real;
		d			:  real;
		cont		:  boolean;
		xx, yy		:  longint;
	begin
		x:=xSize div 2;
		y:=10;
		d:=0;
		cont:=true;
		co:=cos(dir);
		si:=sin(dir);
		while ((x>=0) and (y>=0) and (x<=xSize) and (y<=20) and (d<14) and cont) do begin
			xx:=round(x+xp-xSize div 2);
			yy:=round(y+yp-10);
			while (xx<0) do xx:=0;
			while (xx>mapW) do xx:=mapW;
			while (yy<0) do yy:=0;
			while (yy>mapW) do yy:=mapH;
			if not(map.level[xx,yy].see) then cont:=false;
			isSeen[round(x), round(y)]:=T;
			map.level[xx,yy].isSeen:=T;
			x:=x+co;
			y:=y+si;
			d:=d+1+abs(si);
		end;
	end;
	
begin
	if infoMode then xSize:=54 else xSize:=79;
	itemsHere:=0;
	for x:=0 to xSize do for y:=0 to 20 do begin
		isSeen[x,y]:=F;
	end;
	for x:=0 to 601 do begin
		castRay(double(x)/601*pi*2);
	end;
	for x:=0 to xSize do for y:=1 to 19 do begin
		xx:=x+xp-xSize div 2;
		yy:=y+yp-10;
		if (x=xSize div 2) and (y=10) then begin
			putChar(x,y,ord('@'),15);
		end else if (xx>=0) and (yy>=0) and (xx<=mapW) and (yy<=mapH) then begin
			if (isSeen[x,y]) then begin
				putChar(x,y,map.level[xx,yy].img,map.level[xx,yy].col);
			end else if map.level[xx,yy].isSeen then begin
				putChar(x,y,map.level[xx,yy].img,map.level[xx,yy].col);
			end else 
				putChar(x,y,32, 0);
		end else begin
			putChar(x,y,32, 0);
		end;
	end;
	for i:=0 to 10000 do begin
		if map.item[i]<>nil then begin
			xx:=map.item[i]^.x-xp+xSize div 2;
			yy:=map.item[i]^.y-yp+10;
			if (xx>=0) and (yy>=1) and (xx<=xSize) and (yy<=19) then begin
				if isSeen[xx,yy] then begin
					putChar(xx,yy,map.item[i]^.img,map.item[i]^.col);
				end;
				if (xx=xSize div 2) and (yy=10) then begin
					itemsHere:=itemsHere+1;
					itemStr:='There is '+map.item[i]^.a+' '+map.item[i]^.name+' here.';
				end;
			end;
		end;
	end;
	if itemsHere>0 then begin
		if itemsHere=1 then 
			addMsg(itemStr)
		else if itemsHere<5 then
			addMsg('There is a pile of stuff here.')
		else if itemsHere<20 then 
			addMsg('There is a big pile of stuff here.')
		else
			addMsg('There is a huge pile of stuff here.')
	end;
	putChar(xSize div 2,10,ord('@'),15);
	gotoXY(xSize div 2+1,10+1);
end;

function findMap(var map : tMap; c : char) : tPos;
var
	x, y		:  integer;
begin
	findMap.x:=0;
	findMap.y:=0;
	for x:=0 to MapW do for y:=0 to MapH do begin
		if map.level[x,y].img=ord(c) then begin
			findMap.x:=x;
			findMap.y:=y;
		end;
	end;
end;

function findToMap(var map : tMap; c : longint) : tPos;
var
	x, y		:  integer;
begin
	findToMap.x:=0;
	findToMap.y:=0;
	for x:=0 to MapW do for y:=0 to MapH do begin
		if map.level[x,y].toLevel=c then begin
			findToMap.x:=x;
			findToMap.y:=y;
		end;
	end;
end;

procedure tryMove(var player : tCharacter; var map : pMap; xa, ya :  integer);
var
	foo			:  longint;
	i			:  integer;
begin
	with player do begin
		if map^.level[pos.x+xa,pos.y+ya].pas then begin
			pos.x:=pos.x+xa;
			pos.y:=pos.y+ya;
		end else begin
			if map^.level[pos.x+xa,pos.y+ya].img=ord('*') then begin
				foo:=map^.id;
				if map^.level[pos.x+xa,pos.y+ya].toLevel=-999 then begin
					numLevels:=numLevels+1;
					map^.level[pos.x+xa,pos.y+ya].toLevel:=numLevels;
					saveMap(map);
					new(map);
					for	i:=0 to 10000 do begin
						map^.item[i]:=nil;
					end;
					makeMap(map^,numLevels);
					pos:=findMap(map^,'<');
					map^.level[pos.x,pos.y].toLevel:=foo;
				end else begin
					saveMap(map);
					loadMap(map,map^.level[pos.x+xa,pos.y+ya].toLevel);
					pos:=findToMap(map^,foo);
				end;
				exit;
			end;
			if map^.level[pos.x+xa,pos.y+ya].img=ord('>') then begin
				foo:=map^.id;
				if map^.level[pos.x+xa,pos.y+ya].toLevel=-999 then begin
					numLevels:=numLevels+1;
					map^.level[pos.x+xa,pos.y+ya].toLevel:=numLevels;
					saveMap(map);
					new(map);
					for	i:=0 to 10000 do begin
						map^.item[i]:=nil;
					end;
					makeMap(map^,numLevels);
					pos:=findMap(map^,'<');
					map^.level[pos.x,pos.y].toLevel:=foo;
				end else begin
					saveMap(map);
					loadMap(map,map^.level[pos.x+xa,pos.y+ya].toLevel);
					pos:=findToMap(map^,foo);
				end;
				exit;
			end;
			if map^.level[pos.x+xa,pos.y+ya].img=ord('<') then begin
				foo:=map^.id;
				if map^.level[pos.x+xa,pos.y+ya].toLevel=-999 then begin
					numLevels:=numLevels+1;
					map^.level[pos.x+xa,pos.y+ya].toLevel:=numLevels;
					saveMap(map);
					new(map);
					for	i:=0 to 10000 do begin
						map^.item[i]:=nil;
					end;
					makeMap(map^,numLevels);
					pos:=findMap(map^,'>');
					map^.level[pos.x,pos.y].toLevel:=foo;
				end else begin
					saveMap(map);
					loadMap(map,map^.level[pos.x+xa,pos.y+ya].toLevel);
					pos:=findToMap(map^,foo);
				end;
				exit;
			end;
			if map^.level[pos.x+xa,pos.y+ya].img=ord('o') then begin
				foo:=map^.id;
				if map^.level[pos.x+xa,pos.y+ya].toLevel=-999 then begin
					numLevels:=numLevels+1;
					map^.level[pos.x+xa,pos.y+ya].toLevel:=numLevels;
					saveMap(map);
					new(map);
					for	i:=0 to 10000 do begin
						map^.item[i]:=nil;
					end;
					makeRoomMap(map^,numLevels);
					pos:=findMap(map^,'>');
					map^.level[pos.x,pos.y].toLevel:=foo;
				end else begin
					saveMap(map);
					loadMap(map,map^.level[pos.x+xa,pos.y+ya].toLevel);
					pos:=findToMap(map^,foo);
				end;
			end;
			exit;
		end;
	end;
end;

procedure addItem(var inv : tItemList; var item : tItem);
var
	i			:  integer;
begin
	i:=0;
	while (i<=1000) and (inv[i]<>nil) do i:=i+1;
	if i<=1000 then begin
		new(inv[i]);
		inv[i]^:=item;
	end;
end;


procedure writeItem(x, y : integer; var item : tItem; c : byte);
var
	st		:  string;
begin
	st:=item.name;
	st[1]:=upcase(st[1]);
	putChar(x,y,item.img,item.col);
	skriv(x+2,y,st,c);
	st:=toStr(item.weight)+' g';
	skriv(78-length(st),y,st,c);
end;

procedure writeInv(var inv : tItemList; x, yy, selInv, i1, i2: integer);
var
	y, i		:  integer;
begin
	y:=yy;
	for i:=i1 to i1+i2 do begin
		if inv[i]<>nil then begin
			if i=selInv then begin
				putChar(x,y,ord('>'),15);
				writeItem(x+2,y,inv[i]^,15);
			end else begin
				writeItem(x+2,y,inv[i]^,7);
			end;
			y:=y+1;
		end;
	end;
end;

procedure flattenInv(var inv : tItemList);
var
	i, free		:  integer;
begin
	free:=-1;
	for i:=0 to 1000 do begin
		if inv[i]=nil then 
			free:=i
		else if free>=0 then begin
			inv[free]:=inv[i];
			inv[i]:=nil;
			free:=i;
		end;
	end;
end;

function calcInv(var inv : tItemList) : integer;
var
	i			:  integer;
	res			:  integer;
begin
	res:=0;
	for i:=0 to 1000 do begin
		if inv[i]<>nil then res:=res+1;
	end;
	calcInv:=res;
end;

procedure dropItem(num : integer; var map : tMap; xp, yp : integer);
var
	i			:  integer;
begin
	if inv[num]<>nil then begin
		i:=0;
		while (i<=10000) and (map.item[i]<>nil) do i:=i+1;
		if i<=10000 then begin
			map.item[i]:=inv[num];
			map.item[i]^.x:=xp;
			map.item[i]^.y:=yp;
			inv[num]:=nil;
{			new(map.item[i]);
			map.item[i]^:=inv[num]^;
			dispose(inv[num]);
			inv[num]:=nil;}
		end;
	end;
	flattenInv(inv);
end;

procedure drawMsg;
var
	i		:  integer;
begin
	for i:=maxMsg-3 to maxMsg do begin
		skriv(0,i-(maxMsg-3)+25-4,msg[i],7);
	end;
end;

procedure flipScreen;
var
	x, y		:  integer;
	p			:  integer;
begin
	p:=0;
	for x:=0 to 79 do for y:=0 to 24 do begin
		mem[$b800:p]:=tmpScr[p];
		mem[$b800:p+1]:=tmpScr[p+1];
		p:=p+2;
	end;
{	move(tmpScr[0],mem[$b800:0000],80*50);}
end;

var
	map			:  pMap;
	player		:  tCharacter;
	key			:  string;

procedure openInventory(im : integer);
var
	key			:  string;
	selInv		:  integer;
	totalInv	:  integer;
	ofs			:  integer;
	mode		:  integer;
	oldPos		:  integer;
	tmp			:  pItem;
	invMode		:  integer;
	equipSlot	:  integer;
		
	procedure doInv;
	var
		t		:  pItem;
	begin
		totalInv:=calcInv(inv);
		if selInv<0 then selInv:=0;
		if selInv>=totalInv then selInv:=totalInv-1;
		skrivC(40,0,'[ Your Inventory ]',6);
		skrivC(40,0,' Your Inventory ',14);

		skriv(0,24,line,6);
		
		ofs:=selInv-10;
		if ofs>totalInv-21 then ofs:=totalInv-21;
		if ofs<0 then ofs:=0;
		if totalInv=0 then begin
			skriv(4,24,'[ ftab7 mode 6]',6);
			skrivC(40,12,'You are not carrying anything.',7);
			flipScreen;
			gotoXY(1,2);
			key:=readKey;
			if (key=chr(0)) and (keyPressed) then key:=key+readKey;
			if mode=2 then begin
				mode:=0;
				invMode:=2;
				selInv:=equipSlot;
				if key=chr(9) then key:='';
				if key=' ' then key:='';
			end;
			if key=' ' then key:='Q';
		end else begin
			if mode=0 then begin
				skriv(4,24,'[ fd7 drop 8| fm7 move 8| fu7 use 8| ftab7 mode 6]',6);
			end;
			if mode=1 then begin
				skriv(4,24,'[ eMOVE 8| fspace7 done 6]',6);
			end;
			if mode=2 then begin
				skriv(4,24,'[ eEQUIP 8| fe7 equip 8| fspace7 abort 6]',6);
			end;
			if ofs<totalInv-21 then begin
				skriv(1,23,'-- fMORE6 --',6);
			end;
			if ofs>0 then begin
				skriv(1,1,'-- fMORE6 --',6);
			end;
			
			writeInv(inv,0,2,selInv,ofs,20);
			flipScreen;
			gotoXY(1,2);
			
			key:=readKey;
			if (key=chr(0)) and (keyPressed) then key:=key+readKey;
			if mode=0 then begin
				if key='m' then begin
					mode:=1;
					oldPos:=selInv;
				end;
				if key=' ' then key:='Q';
				if key=chr(0)+'H' then selInv:=selInv-1;
				if key=chr(0)+'P' then selInv:=selInv+1;
				if key=chr(0)+'I' then selInv:=selInv-8;
				if key=chr(0)+'Q' then selInv:=selInv+8;
				if key='d' then begin
					dropItem(selInv,map^, player.pos.x, player.pos.y);
					totalInv:=calcInv(inv);
				end;
			end else if mode=1 then begin
				if key=' ' then mode:=0;
				if key=chr(9) then key:='';
				if key=chr(0)+'H' then selInv:=selInv-1;
				if key=chr(0)+'P' then selInv:=selInv+1;
				if key=chr(0)+'I' then selInv:=selInv-8;
				if key=chr(0)+'Q' then selInv:=selInv+8;
				if selInv<0 then selInv:=0;
				if selInv>=totalInv then selInv:=totalInv-1;
				while selInv<>oldPos do begin
					tmp:=inv[oldPos];
					if oldPos<selInv then inv[oldPos]:=inv[oldPos+1];
					if oldPos>selInv then inv[oldPos]:=inv[oldPos-1];
					if oldPos<selInv then inv[oldPos+1]:=tmp;
					if oldPos>selInv then inv[oldPos-1]:=tmp;
					if oldPos<selInv then oldPos:=oldPos+1;
					if oldPos>selInv then oldPos:=oldPos-1;
				end;
			end else if mode=2 then begin
				if key=chr(9) then key:='';
				if key=chr(0)+'H' then selInv:=selInv-1;
				if key=chr(0)+'P' then selInv:=selInv+1;
				if key=chr(0)+'I' then selInv:=selInv-8;
				if key=chr(0)+'Q' then selInv:=selInv+8;
				if selInv<0 then selInv:=0;
				if selInv>=totalInv then selInv:=totalInv-1;
				
				if key='e' then begin
					t:=equip[equipSlot];
					equip[equipSlot]:=inv[selInv];
					inv[selInv]:=t;
					flattenInv(inv);
					mode:=0;
					invMode:=2;
					selInv:=equipSlot;
				end;
				if key=' ' then begin
					mode:=0;
					invMode:=2;
					selInv:=equipSlot;
				end;
			end;
		end;
	end;	

	procedure doOnGround;
	var
		og			:  tItemList;
		i			:  integer;
		xx, yy		:  integer;
		num			:  array[0..10000] of integer;
		j			:  integer;
		
	begin
		for i:=0 to 1000 do begin
			og[i]:=nil;
		end;
		j:=0;
		for i:=0 to 10000 do begin
			if map^.item[i]<>nil then begin
				xx:=map^.item[i]^.x-player.pos.x+24;
				yy:=map^.item[i]^.y-player.pos.y+10;
				if (xx>=0) and (yy>=0) and (xx<=48) and (yy<=20) then begin
					if (xx=24) and (yy=10) then begin
						addItem(og, map^.item[i]^);
						num[j]:=i;
						j:=j+1;
					end;
				end;
			end;
		end;
		totalInv:=calcInv(og);
		if selInv<0 then selInv:=0;
		if selInv>=totalInv then selInv:=totalInv-1;
		
		skrivC(40,0,'[ On Ground ]',6);
		skrivC(40,0,' On Ground ',14);

		skriv(0,24,line,6);
		
		ofs:=selInv-10;
		if ofs>totalInv-21 then ofs:=totalInv-21;
		if ofs<0 then ofs:=0;
		
		if totalInv=0 then begin
			skriv(4,24,'[ ftab7 mode 6]',6);
			skrivC(40,12,'There is nothing here.',7);
			flipScreen;
			gotoXY(1,2);
			key:=readKey;
			if (key=chr(0)) and (keyPressed) then key:=key+readKey;
			if key=' ' then key:='Q';
		end else begin
			skriv(4,24,'[ f,7 pick up 8| ftab7 mode 6]',6);

			if ofs<totalInv-21 then begin
				skriv(1,23,'-- fMORE6 --',6);
			end;
			if ofs>0 then begin
				skriv(1,1,'-- fMORE6 --',6);
			end;

			writeInv(og,0,2,selInv,ofs,20);
	
			flipScreen;
			gotoXY(1,2);
				
			key:=readKey;
			if (key=chr(0)) and (keyPressed) then key:=key+readKey;
			if key=' ' then key:='Q';
			if key=chr(0)+'H' then selInv:=selInv-1;
			if key=chr(0)+'P' then selInv:=selInv+1;
			if key=chr(0)+'I' then selInv:=selInv-8;
			if key=chr(0)+'Q' then selInv:=selInv+8;
			if key=',' then begin
				addItem(inv, map^.item[num[selInv]]^);
				dispose(map^.item[num[selInv]]);
			end;
			if selInv<0 then selInv:=0;
			if selInv>=totalInv then selInv:=totalInv-1;
		end;
	end;	

	procedure doOnBody;
		
		procedure drawEquip(i, y : integer);
		begin
			if equip[i]<>nil then begin
				if selInv=i then 
					writeItem(10,y,equip[i]^,15)
				else
					writeItem(10,y,equip[i]^,7);
			end;
		end;
		
	var
		y		:  integer;
	begin
		skrivC(40,0,'[ Equipment ]',6);
		skrivC(40,0,' Equipment ',14);

		skriv(0,24,line,6);

		skriv(2,2, '--- 7IN HANDS 6---',6);
		skriv(2,3, ' Right:',6);
		drawEquip(0,3);
		skriv(2,4, '  Left:',6);
		drawEquip(1,4);

		skriv(2,6, '--- 7ARMOUR 6---',6);
		skriv(2,7 ,'  Head:',6);
		drawEquip(2,7);
		skriv(2,8 ,'  Body:',6);
		drawEquip(3,8);
		skriv(2,9 ,' Hands:',6);
		drawEquip(4,9);
		skriv(2,10,'  Feet:',6);
		drawEquip(5,10);

		skriv(2,12,'--- 7JEWELRY 6---',6);
		skriv(2,13,'  Ring:',6);
		drawEquip(6,13);
		skriv(2,14,'  Ring:',6);
		drawEquip(7,14);
		skriv(2,15,'Amulet:',6);
		drawEquip(8,15);

		skriv(4,24,'[ fe7 equip 8| fr7 remove 8| ftab7 mode 6]',6);

		y:=selInv;
		if y>=2 then y:=y+2;
		if y>=8 then y:=y+2;
		skriv(0,y+3,'>',15);
			
		flipScreen;
		gotoXY(1,2);
			
		key:=readKey;
		if (key=chr(0)) and (keyPressed) then key:=key+readKey;

		if key=' ' then key:='Q';
		if key=chr(0)+'H' then selInv:=selInv-1;
		if key=chr(0)+'P' then selInv:=selInv+1;
		if key='e' then begin
			equipSlot:=selInv;
			mode:=2;
			invMode:=0;
			selInv:=0;
		end;
		if key='r' then begin
			if equip[selInv]<>nil then begin
				addItem(inv,equip[selInv]^);
				flattenInv(inv);
				dispose(equip[selInv]);
				equip[selInv]:=nil;
			end;
		end;
		if selInv<0 then selInv:=0;
		if selInv>=8 then selInv:=8;
	end;	
	
begin
	invMode:=im;
	totalInv:=calcInv(inv);
	selInv:=0;
	mode:=0;
	ofs:=0;
	repeat
		fillChar(tmpScr,80*50,0);

		skriv(0,0,line,6);
		if invMode=0 then 
			doInv
		else if invMode=1 then 
			doOnGround
		else if invMode=2 then 
			doOnBody;
		if key=chr(9) then begin
			invMode:=invMode+1;
			selInv:=0;
		end;
		if invMode>2 then begin
			invMode:=0;
		end;
	until (key=chr(27)) or (key='Q');
end;

procedure checkPickUpItem(var map : tMap; xp, yp : integer);
var
	i, xx, yy		:  integer;
	it				:  integer;
begin
	it:=-1;
	for i:=0 to 10000 do begin
		if map.item[i]<>nil then begin
			xx:=map.item[i]^.x-xp+24;
			yy:=map.item[i]^.y-yp+10;
			if (xx>=0) and (yy>=0) and (xx<=48) and (yy<=20) then begin
				if (xx=24) and (yy=10) then begin
					if it<>-1 then 
						it:=-999 
					else
						it:=i;
				end;
			end;
		end;
	end;
	if it>=0 then begin
		addItem(inv, map.item[it]^);
		dispose(map.item[it]);
	end else begin
		if it=-999 then openInventory(1);
	end;
end;

var
	y			:  integer;

begin
	for y:=0 to 20 do begin
		equip[y]:=nil;
	end;
	randomize;
	init;
	new(map);
	numLevels:=0;
	makeTopMap(map^,0);
	player.pos:=findMap(map^,'o');
	
	skriv(0,21,'',7);
	skriv(0,22,'',7);
	skriv(0,23,'',7);
	skriv(0,24,'',7);

	line:='';
	for y:=0 to 79 do line:=line+char(196);
	infoMode:=true;
	
	gotoXY(25,11);
	repeat
		fillChar(tmpScr,80*50,0);
		drawMap(map^, player.pos.x, player.pos.y);

		skriv(0,20,line,6);
		skrivC(40,20,'[ Messages ]',6);
		skrivC(40,20,'Messages',14);
		drawMsg;
		
		skriv(0,0,line,6);
		if infoMode then begin
			skrivC(28,0,'[ Map ]',6);
			skrivC(28,0,'Map',14);
			skrivC(68,0,'[ Player ]',6);
			skrivC(68,0,'Player',14);
			putChar(55,0,194,6);
			for y:=1 to 19 do begin
				putChar(55,y,179,6);
			end;
			putChar(55,20,193,6);
		end else begin
			skrivC(40,0,'[ Map ]',6);
			skrivC(40,0,'Map',14);
		end;
		
		flipScreen;
	
		key:=readKey;
		if (key=chr(0)) and (keyPressed) then key:=key+readKey;
		if key=chr(0)+'H' then tryMove(player, map, 0,-1);
		if key=chr(0)+'I' then tryMove(player, map, 1,-1);
		if key=chr(0)+'M' then tryMove(player, map, 1, 0);
		if key=chr(0)+'Q' then tryMove(player, map, 1, 1);
		if key=chr(0)+'P' then tryMove(player, map, 0, 1);
		if key=chr(0)+'O' then tryMove(player, map,-1, 1);
		if key=chr(0)+'K' then tryMove(player, map,-1, 0);
		if key=chr(0)+'G' then tryMove(player, map,-1,-1);
		if key=',' then begin
			checkPickUpItem(map^, player.pos.x, player.pos.y);
		end;
	
		if key='i' then openInventory(0);
		if key='e' then openInventory(2);
		if key=char(9) then infoMode:=not(infoMode);

{		addMsg(key+'  '+toStr(ord(key[1])));}
	until key='Q';
	dispose(map);
	clear;
end.




{
	--- IN HANDS ---
	 left:
	right:

	--- PROTECTION ---
	 head:
	chest:
	 arms:
	 legs:

	--- JEWELRY ---	
	 ring:
	 ring:
	 neck:
}
